#!/usr/bin/python2
# -*- coding: utf-8 -*-

'''
    Bohrhilfe Programm
'''


import cv
from os import getenv
from PyQt4 import QtGui, QtCore
from sys import argv, exit
import v4l2
import fcntl
from re import search

class Camera(object):
    def __init__(self, camera_id=0):
        self.id = camera_id
        self.capture = cv.CaptureFromCAM(camera_id)
        
        try:
            dev = open('/dev/video' + str(self.id), 'rw')
        except IOError:
            self._dev = None
        else:
            self._dev = dev
        
        if not self._dev == None:
            self._capability = v4l2.v4l2_capability()
            fcntl.ioctl(self._dev, v4l2.VIDIOC_QUERYCAP, self._capability)
            
            self._fmt = v4l2.v4l2_format()
            self._fmt.type = v4l2.V4L2_BUF_TYPE_VIDEO_CAPTURE
            fcntl.ioctl(self._dev, v4l2.VIDIOC_G_FMT, self._fmt)
            
            # get all sizes
            #~ self._frame_sizes = []
            #~ fmt = v4l2.v4l2_format()
            #~ sizes = v4l2.v4l2_frmsizeenum()

            #~ fmt.type = v4l2.V4L2_BUF_TYPE_VIDEO_CAPTURE
            #~ fcntl.ioctl(self.dev, v4l2.VIDIOC_G_FMT, fmt)
    
            #~ sizes.pixel_format = fmt.fmt.pix.pixelformat
            #~ sizes.index = 0
        
            #~ error = 0
            #~ while error == 0:
                #~ try:
                    #~ fcntl.ioctl(self.dev, v4l2.VIDIOC_ENUM_FRAMESIZES, sizes)
                #~ except IOError:
                    #~ error = 1
                #~ else:
                    #~ self._frame_sizes.append((int(sizes._u.discrete.width) , int(sizes._u.discrete.height)))
                    #~ sizes.index+=1
                
            self._height = int(cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_FRAME_HEIGHT))
            self._width = int(cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_FRAME_WIDTH))
            self.fps = int(cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_FPS))
            self.format = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_FORMAT)
            self._brightness = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_BRIGHTNESS)
            self._contrast = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_CONTRAST)
            self._saturation = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_SATURATION)
            self.hue = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_HUE)
            self.gain = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_GAIN)
            self.conv_rgb = cv.GetCaptureProperty(self.capture, cv.CV_CAP_PROP_CONVERT_RGB)
            self._flipped = False
            self._mirror = False
            
            self._dev.close()
        
    #~ def frameSizes(self):
        #~ return self._frame_sizes
    
    #~ def setFrameSizes(self):
        #~ return -1
    
    def name(self):
        return self._capability.card
        
    def setName(self):
        return -1
        
    def dev(self):
        return self._dev
        
    def setDev(self, dev):
        self._dev = dev
        
    def flipped(self):
        return self._flipped
        
    def setFlipped(self, value):
        self._flipped = value
    
    def mirror(self):
        self._mirror
        
    def setMirror(self, value):
        self._mirror = value
        
    def width(self):
        return self._width
        
    def setWidth(self, value):
        self._width = value
        cv.SetCaptureProperty(self.capture, cv.CV_CAP_PROP_FRAME_WIDTH, value)
        
    def height(self):
        return self._height
        
    def setHeight(self, value):
        self._height = value
        cv.SetCaptureProperty(self.capture, cv.CV_CAP_PROP_FRAME_HEIGHT, value)    
        
    def brightness(self):
        return self._brightness
        
    def setBrightness(self, value):
        if(value <= 1.0 and value >=0):
            self._brightness = value
            cv.SetCaptureProperty(self.capture, cv.CV_CAP_PROP_BRIGHTNESS, value)
            return 0
        else:
            return -1
    
    def contrast(self):
        return self._contrast
    
    def setContrast(self, value):
        if(value <= 1.0 and value >= 0):
            self._contrast = value
            cv.SetCaptureProperty(self.capture, cv.CV_CAP_PROP_CONTRAST, value)
            return 0
        else:
            return -1
    
    def saturation(self):
        return self._contrast
    
    def setSaturation(self, value):
        if(value <= 1.0 and value >= 0):
            self._saturation = value
            cv.SetCaptureProperty(self.capture, cv.CV_CAP_PROP_SATURATION, value)
            return 0
        else:
            return -1
            
    # define hidden setter and getter
    name = property(name, setName)
    dev = property(dev, setDev)
    #~ frame_sizes = property(frameSizes, setFrameSizes)
    brightness = property(brightness, setBrightness)
    contrast = property(contrast, setContrast)
    saturation = property(saturation, setSaturation)
    width = property(width, setWidth)
    height = property(height, setHeight)
    flipped = property(flipped, setFlipped)
    
    # weitere Funktionen
    
    def getFrameSizes(self):
        frame_sizes = []
        fmt = v4l2.v4l2_format()
        sizes = v4l2.v4l2_frmsizeenum()

        fmt.type = v4l2.V4L2_BUF_TYPE_VIDEO_CAPTURE
        fcntl.ioctl(self.dev, v4l2.VIDIOC_G_FMT, fmt)
    
        # get all supported framesizes
        sizes.pixel_format = fmt.fmt.pix.pixelformat
        sizes.index = 0
        
        error = 0
        while error == 0:
            try:
                fcntl.ioctl(self.dev, v4l2.VIDIOC_ENUM_FRAMESIZES, sizes)
            except IOError:
                error = 1
            else:
                frame_sizes.append((int(sizes._u.discrete.width) , int(sizes._u.discrete.height)))
                sizes.index+=1
        
        return frame_sizes
            
    def getFrame(self):
        frame = cv.QueryFrame(self.capture)
        
        if self.flipped == True:
            cv.Flip(frame, flipMode=0)
            
        if self.mirror == True:
            cv.Flip(frame, flipMode= 1)
        return frame
        
    def open(self):
        self.capture = cv.CaptureFromCAM(self.id)
        self.dev  = open('/dev/video' + str(self.id), 'rw')
        
    def close(self):
        del(self.capture)
        self.dev.close()
                    
class DrillHelp(Camera):
    def __init__(self, camera_id=0):
        Camera.__init__(self, camera_id)
        
        if not self.dev == None:
            self.zoom = 200
            self.cross = (self.width/2,self.height/2)
            self.draw_cross = True
            self.zoom_width = self.width/2
            self.zoom_height = self.height/2
            self.rectangle_width = self.zoom_width
            self.rectangle_height = self.zoom_height
        
    def drawCross(self, img):
        cv.Circle(img, self.cross, 13, cv.RGB(255, 255, 255), 1)
        cv.Line(img, (self.cross[0], self.cross[1]  -20), (self.cross[0], self.cross[1]  + 20), cv.RGB(0,200,0), 1)
        cv.Line(img, (self.cross[0] + 20, self.cross[1]), (self.cross[0] - 20, self.cross[1]), cv.RGB(0,200,0), 1)
        return img
        
    def drawRectangle(self, img):
        point1 = (self.cross[0] - int((self.rectangle_width/2)/(self.zoom/100.0)), self.cross[1] - int((self.rectangle_height/2)/(self.zoom/100.0))) 
        point2 = (self.cross[0] + int((self.rectangle_width/2)/(self.zoom/100.0)), self.cross[1] + int((self.rectangle_height/2)/(self.zoom/100.0)))
        cv.Rectangle(img, point1, point2, cv.RGB(255, 255, 255), 1)
        return img
        
    def getZoomFrame(self, img, x_pos, y_pos, zoom):
        size_x = int(self.zoom_width/(zoom/100.0))
        size_y = int(self.zoom_height/(zoom/100.0))
        sub = cv.GetSubRect(img, (x_pos-size_x/2, y_pos-size_y/2, size_x, size_y)) 
        
        return self.resizeFrame(sub, self.zoom_width, self.zoom_height)
        
    def resizeFrame(self,img, width, height):
       resized_frame = cv.CreateMat(height, width, cv.CV_8UC3)
       cv.Resize(img, resized_frame)
       return resized_frame
        
class InfoWindow(QtGui.QWidget):
    def __init__(self, parent=None):
        super(InfoWindow, self).__init__(parent)
        
        self.verticalLayout = QtGui.QVBoxLayout(self)
        self.info_text = QtGui.QTextBrowser(self)
        self.info_text.setHtml(u'''<p><b>Über Bohrhilfe</b></p>
                                                <p>Version: 0.3</p>
                                                <p>Author: Albert Krenz (albert.krenz@web.de)</p>
                                                <p>Dieses Tool zeichnet ein Fadenkreuz über die Videoausgabe einer USB Webcam. Dadurch
                                                fällt es leichter die Bohrlöcher in der mitte zu treffen. Das Fadenkreuz kann über klicks im Video
                                                und Zoom-Bereich verschoben werden.</p>''')
        self.verticalLayout.addWidget(self.info_text)
        
class MyApplication(QtGui.QMainWindow):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        
        # Drill objekt erzeugen
        self.drill_list = self.getDrills()
        self.drill_list_index = 0
        
        # Main Window einstellungen
        self.setWindowTitle('Bohrhilfe 0.3')
        self.center()
        
        # Statusbar erzeugen
        self.statusBar()
        
        # Menubar
        self.menubar = self.menuBar()
        
        # Exit Action
        exitAction = QtGui.QAction('&Exit', self)        
        exitAction.setShortcut('Ctrl+Q')
        exitAction.setStatusTip('Programm Beenden')
        exitAction.triggered.connect(QtGui.qApp.quit)
        
        # Datei Menu erzeugen
        self.fileMenu = self.menubar.addMenu('&Datei')
        self.fileMenu.addAction(exitAction)
        
        # Info Menu erzeugen
        infoAction = QtGui.QAction(u'&Über', self)
        self.info_menu = self.menubar.addMenu('&Info')
        self.info_menu.addAction(infoAction)
        self.info_menu.triggered.connect(self.showInfo)
        
        # Main Grid Layout
        self.main_grid = QtGui.QGridLayout()
        
        # Einstellungen Gruppe
        self.grp_einstellungen = QtGui.QGroupBox('Einstellungen')
        self.grp_einstellungen.setStyleSheet('''QGroupBox {
                                                            font-weight: bold;
                                                            border: 1px solid gray;
                                                            margin: 4px;
                                                            padding: 2px;
                                                            }
                                                            
                                                    QGroupBox::title{
                                                        subcontrol-origin: border;
                                                        padding: 7px;
                                                        left: 5px;
                                                        top: -1.8ex;
                                                        }''')
        self.main_grid.addWidget(self.grp_einstellungen, 0,0)
        
        self.setting_area = QtGui.QGridLayout()
        
        # ComboBox fuer Kameraauswahl
        self.combo1 = QtGui.QComboBox(self)
        self.setting_area.addWidget(self.combo1, 0,0, 1, 3)
        self.combo1.activated[str].connect(self.onComboSelect)
        for drill in self.drill_list:
            self.combo1.addItem(drill.name, QtCore.QVariant(drill.id))
            
        # Helligkeit einstellen ueber SpinBox
        self.lbl_brightness = QtGui.QLabel('Helligkeit', self)
        self.setting_area.addWidget(self.lbl_brightness, 1,0,1,2)
        self.spin_brightness = QtGui.QDoubleSpinBox(self)
        self.spin_brightness.setRange(0, 1.0)
        self.spin_brightness.setSingleStep(0.1)
        self.spin_brightness.setValue(self.drill_list[self.drill_list_index].brightness)
        self.spin_brightness.valueChanged.connect(self.changeBrightness)
        self.setting_area.addWidget(self.spin_brightness, 1, 1,1,2) 
        
        # Kontrast einstellen ueber SpinBox
        self.lbl_contrast = QtGui.QLabel('Kontrast', self)
        self.setting_area.addWidget(self.lbl_contrast, 2,0,1,2)
        self.spin_contrast = QtGui.QDoubleSpinBox(self)
        self.spin_contrast.setRange(0, 1.0)
        self.spin_contrast.setSingleStep(0.1)
        self.spin_contrast.setValue(self.drill_list[self.drill_list_index].contrast)
        self.spin_contrast.valueChanged.connect(self.changeContrast)
        self.setting_area.addWidget(self.spin_contrast, 2, 1,1,2) 
        
        # Saettigung einstellen ueber SpinBox
        self.lbl_saturation = QtGui.QLabel(u'Sättigung', self)
        self.setting_area.addWidget(self.lbl_saturation, 3, 0,1,2)
        self.spin_saturation = QtGui.QDoubleSpinBox(self)
        self.spin_saturation.setRange(0, 1.0)
        self.spin_saturation.setSingleStep(0.1)
        self.spin_saturation.setValue(self.drill_list[self.drill_list_index].saturation)
        self.spin_saturation.valueChanged.connect(self.changeSaturation)
        self.setting_area.addWidget(self.spin_saturation, 3, 1,1,2) 
        
        # Auflösung über SpinBox einstellen
        self.lbl_resolution = QtGui.QLabel(u'Auflösung', self)
        self.setting_area.addWidget(self.lbl_resolution, 4, 0,1,2)
        self.combo_resolution = QtGui.QComboBox(self)
        
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        drill.open()
        sizes = drill.getFrameSizes()
        for size in sizes:
            self.combo_resolution.addItem(str(size[0]) + ' x ' +str(size[1]))
        self.combo_resolution.activated[str].connect(self.changeResolution)
        self.setting_area.addWidget(self.combo_resolution, 4, 1, 1, 2) 
        drill.close()
        
        # Kamera Bild Flippen
        self.chk_flip = QtGui.QCheckBox('Flip', self)
        self.setting_area.addWidget(self.chk_flip, 5, 0)
        self.chk_flip.stateChanged.connect(self.changeFlip)
        
        # Kamera Bild Spiegeln
        self.chk_mirror = QtGui.QCheckBox('Spiegeln', self)
        self.setting_area.addWidget(self.chk_mirror, 5, 1)
        self.chk_mirror.stateChanged.connect(self.changeMirror)
        
        # Fadenkreuz aktivieren/deaktivieren
        self.chk_draw_cross = QtGui.QCheckBox('Fadenkreuz', self)
        self.chk_draw_cross.setCheckState(QtCore.Qt.Checked)
        self.setting_area.addWidget(self.chk_draw_cross, 5, 2)
        self.chk_draw_cross.stateChanged.connect(self.changeDrawCross)
        
        # Speichern Button
        self.btn_save = QtGui.QPushButton('Bild Speichern', self)
        self.btn_save.clicked.connect(self.saveImage)
        self.setting_area.addWidget(self.btn_save, 6,0)
        
        self.btn_save_zoom = QtGui.QPushButton('Zoom Speichern', self)
        self.btn_save_zoom.clicked.connect(self.saveImageZoom)
        self.setting_area.addWidget(self.btn_save_zoom, 6,1)
        
        # Leerzeile als Fuellelement zwischen den beiden GroupBoxen
        self.main_grid.addWidget(QtGui.QLabel(''),2,0)
        self.main_grid.setRowStretch(2,1)
        
        self.grp_einstellungen.setLayout(self.setting_area)
        
        # Zoom Group Box
        self.grp_zoom = QtGui.QGroupBox('Zoom')
        self.grp_zoom.setStyleSheet('''QGroupBox {
                                                            font-weight: bold;
                                                            border: 1px solid gray;
                                                            margin: 4px;
                                                            padding: 2px;
                                                            }
                                                            
                                                    QGroupBox::title{
                                                        subcontrol-origin: border;
                                                        padding: 7px;
                                                        left: 5px;
                                                        top: -1.8ex;
                                                        }''')
        self.main_grid.addWidget(self.grp_zoom, 3,0)
        
        # Grid fuer Zoom Bereich
        self.zoom_grid= QtGui.QGridLayout()
        
        # Zoom Video
        self.zoom_area = QtGui.QLabel(self)
        self.zoom_area.setFixedSize(self.drill_list[self.drill_list_index].zoom_width, self.drill_list[self.drill_list_index].zoom_height)
        self.zoom_area.mousePressEvent = self.changeCrossPosZoom
        self.zoom_grid.addWidget(self.zoom_area, 0, 0, 2, 1)
        
        # Zoom Slider
        self.zoom_slider = QtGui.QSlider(QtCore.Qt.Vertical, self)
        self.zoom_slider.setTickInterval(10)
        self.zoom_slider.setMinimum(100)
        self.zoom_slider.setMaximum(500)
        self.zoom_slider.setValue(self.drill_list[self.drill_list_index].zoom)
        self.zoom_slider.valueChanged[int].connect(self.changeValueZoomSlider)
        self.zoom_grid.addWidget(self.zoom_slider, 1,1)
        
        self.grp_zoom.setLayout(self.zoom_grid) # Objekte der GroupBox zuweisen
        
        # main video
        self.video_area = QtGui.QLabel(self)
        self.video_area.setFixedSize(self.drill_list[self.drill_list_index].width, self.drill_list[self.drill_list_index].height)
        self.main_grid.addWidget(self.video_area, 0, 1, 4, 1)
        self.video_area.mousePressEvent = self.changeCrossPos
        
        # Erstes Video Objekt öffnen
        self.drill_list[self.drill_list_index].open()
        
        # Timer Object
        self.timer = QtCore.QBasicTimer()
        # timer alle 100ms aufrufen und an Muter-Objekt (MainWindow) weitergegeben
        self.timer.start(33, self) 
        
        # Central widget das alle anderen Widgets beinhaltet
        self.widget = QtGui.QWidget()
        self.widget.resizeEvent = self.changeWindowSize
        self.widget.setLayout(self.main_grid)
        self.setCentralWidget(self.widget)
        
        self.show()
    
    def saveImage(self):
        img = self.video_area.pixmap()
        savefile = QtGui.QFileDialog(self)
        filename, filter = savefile.getSaveFileNameAndFilter(self, 'Bild speichern', getenv('HOME'), 'Bilddatei (*.jpg);;Portable Network Graphics (*.png)', '*.jpg',QtGui.QFileDialog.DontUseNativeDialog)
        
        # Prüfe ob im Dateinamen bereits Dateityp angegeben ist
        filetype = search('\.jpg|png', filename)
        if filetype == None:
            filetype = search('(?<=\(\*)\.\w+(?=\))', filter)
            filename = filename + filetype.group(0)
        img.save(filename)
        
    def saveImageZoom(self):
        img = self.zoom_area.pixmap()
        savefile = QtGui.QFileDialog(self)
        filename, filter = savefile.getSaveFileNameAndFilter(self, 'Bild speichern', getenv('HOME'), 'Bilddatei (*.jpg);;Portable Network Graphics (*.png)', '*.jpg',QtGui.QFileDialog.DontUseNativeDialog)
        
        # Prüfe ob im Dateinamen bereits Dateityp angegeben ist
        filetype = search('\.jpg|png', filename)
        if filetype == None:
            filetype = search('(?<=\(\*)\.\w+(?=\))', filter)
            filename = filename + filetype.group(0)
        img.save(filename)    
        
    def showInfo(self, event):
        self.info_widget = InfoWindow()
        self.info_widget.show()
        
    def changeFlip(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        if(value == 0):
            drill.flipped = False
        
        if(value==2):
            drill.flipped = True
            
    def changeMirror(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        if(value == 0):
            drill.mirror = False
        
        if(value==2):
            drill.mirror = True
            
    def changeDrawCross(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        if(value == 0):
            drill.draw_cross = False
        
        if(value==2):
            drill.draw_cross = True
            
    def changeResolution(self, value):
        index =  self.drill_list_index
        drill = self.drill_list[index]
        
        # Setze gewünschte Breite und Höhe
        drill.height = int(value.split(' ')[2])
        drill.width = int(value.split(' ')[0])
        
        # Aktualisiere die Größe des Zoom Bereichs, Position des Fadenkreuzes
        drill.zoom_width = drill.width/2
        drill.zoom_height = drill.height/2
        drill.rectangle_width = drill.zoom_width
        drill.rectangle_height = drill.zoom_height
        drill.cross = (drill.width/2, drill.height/2)
        
        # Aktualisiere Haupt Video Window
        self.video_area.setFixedSize(drill.width, drill.height)
        self.video_area.update()
        
        # Aktualisiere Zoom Window
        self.zoom_area.setFixedSize(drill.zoom_width, drill.zoom_height)
        self.zoom_area.update()
        
        # Update main window

        
    def onComboSelect(self):
        # Schließe alte Kamera
        self.drill_list[self.drill_list_index].close()
        
        # Timer stoppen um nicht auf falsche kamera zuzugreifen
        self.timer.stop()
        self.drill_list_index = self.combo1.itemData(self.combo1.currentIndex()).toInt()[0] # Kamera Index ändern
        
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        # Neue Kamera öffnen
        drill.open()
        
        # Einstellungen aktualisieren
        self.spin_brightness.setValue(drill.brightness) # Helligkeit
        self.spin_contrast.setValue(drill.contrast) # Kontrast
        self.spin_saturation.setValue(drill.saturation) # Sättigung
        
        sizes = drill.getFrameSizes()
        self.combo_resolution.clear()
        for size in sizes:
            self.combo_resolution.addItem(str(size[0]) + ' x ' +str(size[1]))
        self.combo_resolution.activated[str].connect(self.changeResolution)
        self.setting_area.addWidget(self.combo_resolution, 4, 1) 
        
        # Timer wieder starten
        self.timer.start(33, self)
        
    def changeBrightness(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        drill.brightness = value
        
    def changeContrast(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        drill.contrast = value
    
    def changeSaturation(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        drill.saturation = value
        
    def center(self):
        screen = QtGui.QDesktopWidget().screenGeometry()
        size =  self.geometry()
        self.move((screen.width()-size.width())/2, (screen.height()-size.height())/2)
        
    def changeWindowSize(self, event):
        self.video_area.resize(self.widget.width()-self.grp_zoom.width(), self.widget.height())
    
    def changeCrossPos(self, event):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        point = drill.cross
        drill.cross = (event.x(), event.y())
        
    def changeCrossPosZoom(self,event):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        #print(event.x(), event.y())
        x_diff = int((event.x()-drill.zoom_width/2)/(drill.zoom / 100.0))
        y_diff = int((event.y()-drill.zoom_height/2)/(drill.zoom / 100.0))
        
        drill.cross = (drill.cross[0]+x_diff, drill.cross[1]+y_diff)
        
    def changeValueZoomSlider(self, value):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        drill.zoom = value

    # Timer Event des Hauptfensters
    def timerEvent(self, e):
        index = self.drill_list_index
        drill = self.drill_list[index]
        
        frame = drill.getFrame()
        if drill.draw_cross == True:
            frame = drill.drawCross(frame)
            frame = drill.drawRectangle(frame)
        pixmap = self.convertFrameToPixmap(frame)
        self.video_area.setPixmap(pixmap)
        
        # Zoom anzeigen
        zoom_frame = drill.getZoomFrame(frame, drill.cross[0], drill.cross[1], drill.zoom)
        pixmap = self.convertFrameToPixmap(zoom_frame)
        self.zoom_area.setPixmap(pixmap)
        
    def convertFrameToPixmap(self, img):
        image = QtGui.QImage(img.tostring(), img.width, img.height, QtGui.QImage.Format_RGB888).rgbSwapped()
        pixmap = QtGui.QPixmap.fromImage(image)
        return pixmap
        
    def getDrills(self):
        drills = []
        i = 0
        while True:
            temp_drill = DrillHelp(i)
            if temp_drill.dev == None:
                del(temp_drill)
                break
            else:
                drills.append(temp_drill)
                i += 1
        
        for drill in drills:
            drill.close()
            
        return drills
        
def main():
    app = QtGui.QApplication(argv)
    widget = MyApplication()
    exit(app.exec_())
    
if __name__ == '__main__':
    main()